###########################################################################
#                                                                         #
# File   :	gv_oplist.tcl                                             #
# Project:	TkMount                                                   #
#                                                                         #
# Started:	22.09.97                                                  #
# Changed:	22.09.97                                                  #
# Author :      Gerhard Vogt                                              #
#                                                                         #
# Description:	This fil contains the dialogs to configure the mount-     #
#               options and the mount-picture.                            #
#                                                                         #
# Copyright (C) 1997 by Gerhard Vogt                                      #
#                                                                         #
# This program is free software; you can redistribute it and/or modify    #
# it under the terms of the GNU General Public License as published by    #
# the Free Software Foundation; either version 2 of the License, or       #
# (at your option) any later version.                                     #
#                                                                         #
# This program is distributed in the hope that it will be useful,         #
# but WITHOUT ANY WARRANTY; without even the implied warranty of          #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           #
# GNU General Public License for more details.                            #
#                                                                         #
# You should have received a copy of the GNU General Public License       #
# along with this program; if not, write to the Free Software             #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               #
# See the file "COPYING" in the base directory of this distribution       #
# for more.                                                               #
#                                                                         #
###########################################################################

###########################################################################
# Initialise variables                                                    #
###########################################################################

set options "no options"
set optrw ""
set optn 0
set optt 0
set optv 0
set optf 0
set opta 0
set optt1 ""
set picchoise ""

proc gv_makeOp {} {
global opta optrw optn optv optf optt options optt1

  set options ""
  if {$optrw != ""} {
   set options "$options $optrw"}
  if {$opta == 1} {
   set options "$options -a"}
  if {$optn == 1} {
   set options "$options -n"}
  if {$optv == 1} {
   set options "$options -v"}
  if {$optf == 1} {
   set options "$options -f"}
  if {($optt1 != "")&&($optt1!="none")} {
   set options "$options -t $optt1"}
  if {$options == ""} {
    set options "no options"}
  }

proc gv_oplist {ausdr} {

global path options opta optrw optn optv optf optt  optt1

set w ws

set optt " "
set optrw ""
set optn 0
set optt 0
set optv 0
set optf 0
set opta 0
set optt1 ""


if {[regexp {\-t minix} $ausdr] == 1} {
 set optt1 "minix"}
if {[regexp {\-t ext} $ausdr] == 1} {
 set optt1 "ext"}
 if {[regexp {\-t ext2} $ausdr] == 1} {
 set optt1 "ext2"}
 if {[regexp {\-t xiafs} $ausdr] == 1} {
 set optt1 "xiafs"}
 if {[regexp {\-t hpfs} $ausdr] == 1} {
 set optt1 "hpfs"}
 if {[regexp {\-t umsdos} $ausdr] == 1} {
 set optt1 "umsdos"}
 if {[regexp {\-t msdos} $ausdr] == 1} {
 set optt1 "msdos"}
 if {[regexp {\-t vfat} $ausdr] == 1} {
 set optt1 "vfat"}
 if {[regexp {\-t proc} $ausdr] == 1} {
 set optt1 "proc"}
 if {[regexp {\-t nfs} $ausdr] == 1} {
 set optt1 "nfs"}
 if {[regexp {\-t iso9660} $ausdr] == 1} {
 set optt1 "iso9660"}
 if {[regexp {\-t smbf} $ausdr] == 1} {
 set optt1 "smbf"}
 if {[regexp {\-t ncpf} $ausdr] == 1} {
 set optt1 "ncpf"}
 if {[regexp {\-t affs} $ausdr] == 1} {
 set optt1 "affs"}
 if {[regexp {\-t ufs} $ausdr] == 1} {
 set optt1 "ufs"}
 if {[regexp {\-t romfs} $ausdr] == 1} {
 set optt1 "romfs"}
 if {[regexp {\-t sysv} $ausdr] == 1} {
 set optt1 "sysv"}
 if {[regexp {\-t xenix} $ausdr] == 1} {
 set optt1 "xenix"}
 if {[regexp {\-t} $ausdr] == 0} {
 set optt1 "none"} 
 if {[regexp {\-r} $ausdr] == 1} {
 set optrw "-r"}
 if {[regexp {\-w} $ausdr] == 1} {
 set optrw "-w"}
 if {[regexp {\-v} $ausdr] == 1} {
 set optv "1"}
 if {[regexp {\-n} $ausdr] == 1} {
 set optn "1"}
 if {[regexp {\-a} $ausdr] == 1} {
 set opta "1"}
 if {[regexp {\-f} $ausdr] == 1} {
 set optf "1"}     

gv_makeOp

# set options $ausdr

  catch {destroy .wopt}
  toplevel .wopt -class Dialog
  wm title .wopt Mountoptions

frame .wopt.bottom
frame .wopt.main
frame .wopt.top

frame .wopt.main.right -relief ridge -borderwidth 4
frame .wopt.main.left -relief ridge -borderwidth 4

label .wopt.top.option -textvariable options
pack .wopt.top .wopt.main .wopt.bottom -side top
pack .wopt.main.left .wopt.main.right -in .wopt.main -side left -pady 0m -padx 0m -fill both
pack .wopt.top.option -in .wopt.top -fill both

checkbutton .wopt.main.left.b1 -text "-v Verbose" -anchor w -variable optv -command {gv_makeOp}
checkbutton .wopt.main.left.b2 -text "-f Fake" -anchor w -variable optf -command {gv_makeOp}
radiobutton .wopt.main.left.b3 -text "-r Mount read only" -anchor w -variable optrw -value "-r" -command {gv_makeOp}
radiobutton .wopt.main.left.b4 -text "-w Mount read/write" -anchor w -variable optrw -value "-w" -command {gv_makeOp}
checkbutton .wopt.main.left.b5 -text "-n No writing in mtab" -anchor w -variable optn -command {gv_makeOp}
checkbutton .wopt.main.left.b6 -text "-a Auto" -anchor w -variable opta -command {gv_makeOp}

frame .wopt.main.right.top
frame .wopt.main.right.bottom
frame .wopt.main.right.bottom.f1
frame .wopt.main.right.bottom.f2
pack .wopt.main.right.top .wopt.main.right.bottom -in .wopt.main.right -side top -fill both
pack .wopt.main.right.bottom.f1 .wopt.main.right.bottom.f2 -in .wopt.main.right.bottom -side left -fill both
label .wopt.main.right.top.b5 -text "-t Filesystem" -anchor w
radiobutton .wopt.main.right.bottom.f1.r1 -text "minix" -variable optt1 -value minix -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r2 -text "ext" -variable optt1 -value ext -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r3 -text "ext2" -variable optt1 -value ext2 -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r4 -text "xiafs" -variable optt1 -value xiafs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r5 -text "hpfs" -variable optt1 -value hpfs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r6 -text "msdos" -variable optt1 -value msdos -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r7 -text "umsdos" -variable optt1 -value umsdos -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r8 -text "vfat" -variable optt1 -value vfat -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r9 -text "proc" -variable optt1 -value proc -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f1.r10 -text "nfs" -variable optt1 -value nfs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r11 -text "iso9660" -variable optt1 -value iso9660 -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r12 -text "smbf" -variable optt1 -value smbf -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r13 -text "ncpf" -variable optt1 -value ncpf -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r14 -text "affs" -variable optt1 -value affs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r15 -text "ufs" -variable optt1 -value ufs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r16 -text "romfs" -variable optt1 -value romfs -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r17 -text "sysv" -variable optt1 -value sysv -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r18 -text "xenix" -variable optt1 -value xenix -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r19 -text "coherent" -variable optt1 -value coherent -anchor w -command {gv_makeOp}
radiobutton .wopt.main.right.bottom.f2.r20 -text "none" -variable optt1 -value none -anchor w -command {gv_makeOp}

pack .wopt.main.left.b1 .wopt.main.left.b2 .wopt.main.left.b3 .wopt.main.left.b4 .wopt.main.left.b5 .wopt.main.left.b6 -in .wopt.main.left -side top -fill x
pack .wopt.main.right.top.b5 -in .wopt.main.right.top -fill x

pack .wopt.main.right.bottom.f1.r1 .wopt.main.right.bottom.f1.r2 .wopt.main.right.bottom.f1.r3 .wopt.main.right.bottom.f1.r4 .wopt.main.right.bottom.f1.r5 .wopt.main.right.bottom.f1.r6 .wopt.main.right.bottom.f1.r7 .wopt.main.right.bottom.f1.r8 .wopt.main.right.bottom.f1.r9 .wopt.main.right.bottom.f1.r10 -in .wopt.main.right.bottom.f1 -side top -fill x
pack .wopt.main.right.bottom.f2.r11 .wopt.main.right.bottom.f2.r12 .wopt.main.right.bottom.f2.r13 .wopt.main.right.bottom.f2.r14 .wopt.main.right.bottom.f2.r15 .wopt.main.right.bottom.f2.r16 .wopt.main.right.bottom.f2.r17 .wopt.main.right.bottom.f2.r18 .wopt.main.right.bottom.f2.r19 .wopt.main.right.bottom.f2.r20 -in .wopt.main.right.bottom.f2 -side top -fill x

button .wopt.bottom.ok -text OK -command {
  destroy .wopt
  if {$options == "no options"} {
        set options ""}
  set mountpoint $options
    .cw.left.frame$oplistnr.entry1$oplistnr delete 0 end
    .cw.left.frame$oplistnr.entry1$oplistnr insert 0 $mountpoint
  }
button .wopt.bottom.cancel -text Cancel -command {
  destroy .wopt
  set options ""
  }
pack .wopt.bottom.ok .wopt.bottom.cancel -side left -fill x

  wm withdraw .wopt
  update idletasks
  set x [expr [winfo screenwidth .wopt]/2 -[winfo reqwidth .wopt]/2 - [winfo vrootx [winfo parent .wopt]]]
  set y [expr [winfo screenheight .wopt]/2 -[winfo reqheight .wopt]/2 - [winfo vrooty [winfo parent .wopt]]]
  wm geom .wopt +$x+$y
  wm deiconify .wopt
  grab set .wopt
}

proc gv_piclist {ausdr} {
        
  global picchoise piclistnr

  set otherpic ""
  catch {destroy .picw}
  toplevel .picw -class Dialog
  wm title .picw Pictures

  frame .picw.top -relief ridge -borderwidth 4
  frame .picw.bottom
  pack .picw.top -in .picw -side top
  pack .picw.bottom -in .picw -side top -padx 0m -pady 0m -fill both

  eval set picchoise $ausdr

  button .picw.bottom.cancel -text Cancel -command {destroy .picw}
  button .picw.bottom.ok -text Ok -command {
    set picture$piclistnr $picchoise
    destroy .picw}

  pack .picw.bottom.ok .picw.bottom.cancel -in .picw.bottom -side left
  radiobutton .picw.top.radio1 -text "CD-Rom" -variable picchoise \
              -value "CD-Rom" -anchor w
  radiobutton .picw.top.radio2 -text "Disk" -variable picchoise -value Disk \
              -anchor w
  radiobutton .picw.top.radio3 -text "Zip-Drive" -variable picchoise \
              -value "Zip-Drive" -anchor w
  radiobutton .picw.top.radio4 -text "Network" -variable picchoise \
              -value "Network" -anchor w
  radiobutton .picw.top.radio5 -text "Harddisk" -variable picchoise \
              -value "Harddisk" -anchor w
  if {($picchoise != "Harddisk") && ($picchoise != "Network") && ($picchoise != "Disk") && ($picchoise != "CD-Rom") && ($picchoise != "Zip-Drive")} {
    radiobutton .picw.top.radio6 -text "Other" -variable picchoise \
              -value $picchoise -anchor w} else {
    radiobutton .picw.top.radio6 -text "Other" -variable picchoise \
              -value Other -anchor w}
  entry .picw.top.entry -width 15 -relief sunken -bd 2\
              -textvariable picchoise 
  bind all <Any-KeyPress> {
    catch {destroy .picw.top.radio6}
  if {($picchoise != "Harddisk") && ($picchoise != "Network") && ($picchoise != "Disk") && ($picchoise != "CD-Rom") && ($picchoise != "Zip-Drive")} {
    radiobutton .picw.top.radio6 -text "Other" -variable picchoise \
              -value $picchoise -anchor w} else {
    radiobutton .picw.top.radio6 -text "Other" -variable picchoise \
              -value Other -anchor w}
  pack .picw.top.radio1 .picw.top.radio2 .picw.top.radio3 .picw.top.radio4 \
       .picw.top.radio5 .picw.top.radio6 .picw.top.entry -in .picw.top -side top -fill both
              }
  
  pack .picw.top.radio1 .picw.top.radio2 .picw.top.radio3 .picw.top.radio4 \
       .picw.top.radio5 .picw.top.radio6 .picw.top.entry -in .picw.top -side top -fill both
  wm withdraw .picw
  update idletasks
  set x [expr [winfo screenwidth .picw]/2 -[winfo reqwidth .picw]/2 - [winfo vrootx [winfo parent .picw]]]
  set y [expr [winfo screenheight .picw]/2 -[winfo reqheight .picw]/2 - [winfo vrooty [winfo parent .picw]]]
  wm geom .picw +$x+$y
  wm deiconify .picw
  grab set .picw
  }